import java.io.IOException;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.List;
import javax.microedition.lcdui.Image;

/*
 * Created August 2004
 */

/**
 * @author johan khne
 */
public class BrowseForm extends List implements CommandListener  {

	Controller controller;
	Command backCommand;
	Command openCommand;
	Command nqCommand;
	Command clearCommand;
	Command jumpCommand;
	Command quitCommand;
	Image folderImage;
	Image fileImage;
	
	public BrowseForm(Controller controller) {
		super("Browser", List.IMPLICIT);
		this.controller = controller;
		setCommandListener(this);
		
		nqCommand = new Command("Enqueue", Command.ITEM, 1);
		addCommand(nqCommand);
		
		jumpCommand = new Command("Jump", "Jump to...", Command.ITEM, 1);
		addCommand(jumpCommand);
		
		clearCommand = new Command("Clr Plylst", "Clear playlist", Command.SCREEN, 4);
		addCommand(clearCommand);
		
		quitCommand = new Command("Quit", "Quit Browser", Command.SCREEN, 5);
		addCommand(quitCommand);
		
		openCommand = new Command(">>", Command.ITEM, 1);
		addCommand(openCommand);
		setSelectCommand(openCommand);
		
		backCommand = new Command("Up", Command.BACK, 1);
		addCommand(backCommand);
		
		try {
			folderImage = Image.createImage("/folder.png");
			fileImage = Image.createImage("/file.png");
		} catch (IOException e) {
			// no image found... hm
		}
	}
	
	public void jumpTo(String jumpTo) {
		setSelectedIndex(controller.protocol.fileBrowser.fetchIndex(jumpTo), true);
	}
	
	void updateDirList(String[] dirs, String[] files, boolean dirChanged) {
		
		int n, i, index = 0;
		
		for (n=0; n < dirs.length; ++n) {
			String name = dirs[n];
			if (index < size()) {
				set(index, name, folderImage);
			}
			else {
				insert(index, name, folderImage);
			}
			setFont(index, Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
			index++;
		}
		for (i=0; i < files.length; ++i) {
			String name = files[i];
			if (index < size()) {
				set(index, name, fileImage);
			}
			else {
				insert(index, name, fileImage);
			}
			setFont(index, Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
			index++;
		}
		
		
		// the outer while might look strange, but it helped fix a list update bug.
		// logically speaking, the inner for-loop would do its job right the first time.
		// guess what, it doesnt... dont ask me.
		while (index < size()) {
			for (i = index; i < size(); i++) {
				delete(i);
			}
		}
		
		// setTitle
		setTitle(controller.protocol.fileBrowser.activeDir());

		// if we just changed dir, set selected item to the first again		
		if (size() > 0 && dirChanged) {
			setSelectedIndex(0, true);
		}
	}
	
	public void commandAction(Command cmd, Displayable display) {
		if (cmd == backCommand) {
			setTitle("Loading...");
			controller.protocol.fileBrowser.moveDirUp();
		}
		else if (cmd == openCommand) {
			setTitle("Loading...");
			controller.protocol.fileBrowser.openItem(getSelectedIndex());
		}
		else if (cmd == nqCommand) {
			controller.protocol.fileBrowser.enqueue(getSelectedIndex());
		}
		else if (cmd == quitCommand) {
			controller.showController();
		}
		else if (cmd == jumpCommand) {
			controller.showJumper();
		}
		else if (cmd == clearCommand) {
			controller.protocol.clearPlaylist();
		}
	}

}
